<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
  <title>awsassist.phpmF</title>
</head>
<body>
<?php
require_once("./awsassist.php");

function hex_dump($data,$title="") {
  if ($title!=="") {
    print(htmlspecialchars($title)."<br>\n");
  }
  for ($j=0;$j<strlen($data);$j+=4) {
    if ($j % 16 == 0 && $j != 0) print("<br>\n");
    if ($j % 16 == 0) print(substr("00000000".dechex($j),-8).":");
    $c1 = ord(substr($data, $j+0, 1));
    $c2 = ord(substr($data, $j+1, 1));
    $c3 = ord(substr($data, $j+2, 1));
    $c4 = ord(substr($data, $j+3, 1));
    $w = $c1 << 24 | $c2 << 16 | $c3 << 8 | $c4;
    print(substr(substr("00000000".dechex($w),-8),0,8-(($j+4>strlen($data))?(strlen($data) % 4)*2:0))." ");
  }
  print("<br>\n");
}
?>
<?php
// HMAC-SHA256
$title="HMAC-SHA256 test";
$data="Sample message for keylen=blocklen";
$key=pack('H*',"000102030405060708090A0B0C0D0E0F".
               "101112131415161718191A1B1C1D1E1F".
               "202122232425262728292A2B2C2D2E2F".
               "303132333435363738393A3B3C3D3E3F");
$ans=pack('H*',"8BB9A1DB9806F20DF7F77B82138C7914".
               "D174D59E13DC4D0169C9057B133E1D62");

$hashed=aa_hmacsha256($data,$key,true);
?>
<table border="1">
  <caption><?php echo $title ?></caption>
  <tr>
    <td>Data</td><td><?php echo htmlspecialchars($data); ?></td>
  </tr>
  <tr>
    <td>Key</td><td><?php hex_dump($key); ?></td>
  </tr>
  <tr>
    <td>Signature<?php if ($ans===$hashed) print(" - OK"); else print(" - NG"); ?></td><td><?php hex_dump($hashed); ?></td>
  </tr>
</table>
<?php
// Product Advertising API Example REST Requests

$ans="http://webservices.amazon.com/onca/xml?AWSAccessKeyId=00000000000000000000&ItemId=0679722769&Operation=ItemLookup&ResponseGroup=ItemAttributes%2COffers%2CImages%2CReviews&Service=AWSECommerceService&Timestamp=2009-01-01T12%3A00%3A00Z&Version=2009-01-06&Signature=Nace%2BU3Az4OhN7tISqgs1vdLBHBEijWcBeCqL5xN9xg%3D";

// ItemLoookup
$title="Itemlookup - function(aa_signrequest)";
$baseurl="http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=00000000000000000000&Operation=ItemLookup&ItemId=0679722769&ResponseGroup=ItemAttributes,Offers,Images,Reviews&Version=2009-01-06";
$url=$baseurl."&Timestamp=2009-01-01T12:00:00Z";
$key="1234567890";
$rurl=aa_signrequest($url,$key);

?>
<table border="1">
  <caption><?php echo $title ?></caption>
  <tr>
    <td>BaseRequest</td><td><?php echo htmlspecialchars($baseurl); ?></td>
  </tr>
  <tr>
    <td>Append Timestamp()</td><td><?php echo htmlspecialchars($url); ?></td>
  </tr>
  <tr>
    <td>Signed Request<?php if ($ans===$rurl) print(" - OK"); else print(" - NG"); ?></td><td><?php echo htmlspecialchars($rurl); ?></td>
  </tr>
  <tr><td colspan="2">p[^̓fR[hƃGR[h{܂BȂ̂ŁAŒA&amp;=Ŋep[^ƁAkey/value؂蕪OK<br>p[^Timestamp͖ΎIɂ܂BAPI}jÃTvƈvׂɎw肵Ă܂</td></tr>
</table>
<?php
// Product Advertising API Example REST Requests

// ItemLoookup
$title="Itemlookup - function(aa_makesignedrequest)";
$url="http://webservices.amazon.com/onca/xml";
$params=array();
$params['Service']="AWSECommerceService";
$params['AWSAccessKeyId']="00000000000000000000";
$params['Operation']="ItemLookup";
$params['ItemId']="0679722769";
$params['ResponseGroup']="ItemAttributes,Offers,Images,Reviews";
$params['Version']="2009-01-06";
$params['Timestamp']="2009-01-01T12:00:00Z";
$key="1234567890";

$rurl=aa_makesignedrequest($url,$params,$key);

?>
<table border="1">
  <caption><?php echo $title ?></caption>
  <tr>
    <td>BaseUrl</td><td><?php echo htmlspecialchars($url); ?></td>
  </tr>
  <tr>
    <td>Request Parameters</td><td><?php print("<pre>");print_r($params);print("</pre>"); ?></td>
  </tr>
  <tr>
    <td>Signed Request<?php if ($ans===$rurl) print(" - OK"); else print(" - NG"); ?></td><td><?php echo htmlspecialchars($rurl); ?></td>
  </tr>
  <tr><td colspan="2">aa_makesignedrequestgpꍇAp[^KeyValueOɃGR[hȂ悤ɒӁB<br>p[^Timestamp͖ΎIɂ܂BAPI}jÃTvƈvׂɎw肵Ă܂</td></tr>
</table>
</body>
</html>
